[[> :header]]

<ol class="breadcrumb">
  [[> :templateBreadcrumb uri=":Start" label="Home"]]

  [[#if (urlParam "bookiri")]]
    [[> :templateBreadcrumb uri=":listBooks" label="Books"]]
    <li class="breadcrumb-item">
      <semantic-query
        query='SELECT ?book_name ?book WHERE { ?book ecrm:P3_has_note ?book_name . BIND(<[[urlParam "bookiri"]]> as ?book ) }'
        template='{{#each bindings}}
          <semantic-link uri="{{book.value}}" urlqueryparam-tab="parts">{{book_name.value}}</semantic-link>
        {{/each}}'
      >
      </semantic-query>
    </li>

    [[#if (urlParam "returniri")]]

      <li class="breadcrumb-item">
        <semantic-link
          uri="[[urlParam "returniri"]]"
          [[#if (urlParam "returntab" )]]
            urlqueryparam-tab="[[urlParam "returntab"]]"
          [[/if]]
          [[#if (urlParam "attributeassignmentiri" )]]
            urlqueryparam-attributeassignmentiri="[[urlParam "attributeassignmentiri"]]"
          [[/if]]
          [[#if (urlParam "bookiri" )]]
            urlqueryparam-bookiri="[[urlParam "bookiri"]]"
          [[/if]]
        >Add Part to Book</semantic-link>
      </li>

    [[/if]]

  [[else]]

    <li class="breadcrumb-item">
      <semantic-link uri="http://sphaera.mpiwg-berlin.mpg.de/resource/listAdaptions">Adaptions</semantic-link>
    </li>
    <li class="breadcrumb-item">
      <semantic-query
        query='SELECT ?adaption_name WHERE
          {
            ?? ecrm:P3_has_note ?adaption_name .
          }'
        template='{{#each bindings}}
            <semantic-link uri=":viewAdaption"
              urlqueryparam-adaptioniri="[[this]]"
            >
              {{adaption_name.value}}
            </semantic-link>
          </li>{{/each}}'
        >
      </semantic-query>
    </li>

  [[/if]]


</ol>

<h1>
  <semantic-query
    query='SELECT ?adaption_name WHERE {
      ??  ecrm:P3_has_note ?adaption_name .
    }'
    template='{{#each bindings}}{{adaption_name.value}} <small>Adaption</small>{{/each}}'
    >
    </semantic-query>
  </h1>

<semantic-form
  persistence='LDP'
  browser-persistence='true'

  [[#if (urlParam "returniri")]]
    post-action="[[urlParam "returniri"]]"
  [[/if]]

  [[#if (urlParam "returntab")]]
    urlqueryparam-tab="[[urlParam "returntab"]]"
    urlqueryparam-returntab="[[urlParam "returntab"]]"
  [[/if]]

  [[#if (urlParam "bookiri")]]
    urlqueryparam-bookiri="[[urlParam "bookiri"]]"
  [[/if]]

  [[#if (urlParam "attributeassignmentiri" )]]
    urlqueryparam-attributeassignmentiri="[[urlParam "attributeassignmentiri"]]"
  [[/if]]

  fields="[[fieldDefinitions
    adaption_type="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/adaption_type"
    custom_identifier="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/custom_identifier"
    doi="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/doi"
    expression_creation="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/part_expression_creation"
    expression_record_type="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/F22_self-contained_expression_record_type"
    part_annotated="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/part_annotated"
    primary_title="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/primary_part_title"
    record_type="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/part_adaption_record_type"
    short_title="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/short_title"
    work_record="http://sphaera.mpiwg-berlin.mpg.de/instances/fields/work_record"
  ]]"

>

  <bs-tab-container id="part-edit-form" class="bs-left-vertical-tabs" default-active-key="[[#if (urlParam "tab" )]][[urlParam "tab"]][[else]]description[[/if]]">
    <bs-row class="clearfix">
      <bs-col sm="2" >
        <bs-nav bs-style="tabs" stacked="true">
          <bs-nav-item event-key="description">
            Description
          </bs-nav-item>
          <bs-nav-item event-key="creator">
            Creators
          </bs-nav-item>
          <bs-nav-item event-key="annotates">
            Annotates
          </bs-nav-item>
          <bs-nav-item event-key="translates">
            Translates
          </bs-nav-item>
          <bs-nav-item event-key="meta">
            Annotations
          </bs-nav-item>

          [[#if (hasPermission "api:config")]]
            <bs-nav-item event-key="delete">
              Delete
            </bs-nav-item>
            <bs-nav-item event-key="hidden" class="hidden-field">
              Hidden
            </bs-nav-item>
            <bs-nav-item event-key="statements">
              Statements
            </bs-nav-item>
          [[/if]]

          </bs-nav>
      </bs-col>
      <bs-col sm="10">

        <bs-tab-content animation="true">

          <bs-tab-pane event-key="description">
            <h3>Description</h3>

            <semantic-form-text-input for="short_title">
            </semantic-form-text-input>

            <semantic-form-text-input for="primary_title" multiline="true">
            </semantic-form-text-input>

            <semantic-form-text-input for="custom_identifier"></semantic-form-text-input>

            <semantic-form-select-input for="adaption_type"></semantic-form-select-input>

          </bs-tab-pane>

          <bs-tab-pane event-key="creator">
            <h3>Creators</h3>
            <semantic-table config='{
              "query":"SELECT ?carried_out_by ?creator_name WHERE {
                  ?? efrbroo:R17i_was_created_by/ecrm:PC01_is_domain_of ?carried_out_by .
                  ?carried_out_by ecrm:PC02_has_range ?creator .
                  ?creator ecrm:P48_has_preferred_identifier/ecrm:P3_has_note ?creator_name .

                 }",
                "columnConfiguration" : [
                 {
                    "displayName" : "Creator",
                    "cellTemplate" : "<semantic-link
                      uri=\":addAuthorToPart\"
                      urlqueryparam-carriedoutbyiri=\"{{carried_out_by.value}}\"
                      urlqueryparam-partiri=\"[[this]]\"
                      urlqueryparam-returntab=\"creator\"
                      [[#if (urlParam "bookiri")]]
                        urlqueryparam-bookiri=\"[[urlParam "bookiri"]]\"
                      [[/if]]
                      [[#if (urlParam "attributeassignmentiri")]]
                        urlqueryparam-attributeassignmentiri=\"[[urlParam "attributeassignmentiri"]]\"
                      [[/if]]\">
                      {{creator_name.value}}
                    </semantic-link>"
                 },
                 {
                   "displayName" : "&nbsp;",
                   "cellTemplate" : "<div>
                                       <mp-ldp-remove-from-container-action
                                         iri=\"{{carried_out_by.value}}/container\"
                                         container=\"http://www.metaphacts.com/ontologies/platform#formContainer\">

                                          <i class=\"fa fa-trash\" aria-hidden=\"true\"></i>

                                       </mp-ldp-remove-from-container-action>

                                   </div>"
                 }
               ],
               "layout":{
                 "options":{
                   "showFilter":false
                 }
               }
             }'>
             </semantic-table>

            <semantic-link
              class="btn btn-md btn-default"
              uri="http://sphaera.mpiwg-berlin.mpg.de/resource/addAuthorToPart"
              urlqueryparam-partiri="[[this]]"
              urlqueryparam-returntab="creator"
              [[#if (urlParam "bookiri")]]
                urlqueryparam-bookiri="[[urlParam "bookiri"]]"
              [[/if]]
              [[#if (urlParam "attributeassignmentiri")]]
                urlqueryparam-attributeassignmentiri="[[urlParam "attributeassignmentiri"]]"
              [[/if]]
              [[#if (urlParam "returniri")]]
                urlqueryparam-returniri="[[urlParam "returniri"]]"
              [[/if]]
              [[#if (urlParam "returntab")]]
                urlqueryparam-returntab="[[urlParam "returntab"]]"
              [[/if]]>
                Add creator
              </semantic-link>
          </bs-tab-pane>

          <bs-tab-pane event-key="annotates">
            <h3>Annotates Part</h3>

            <p>
              If the adaption consists of annotations of one or several existing parts, this can be specified here.
            </p>

            <semantic-form-select-input for="part_annotated"></semantic-form-select-input>

          </bs-tab-pane>


          <bs-tab-pane event-key="translates">
            <h3>Translates Part</h3>
            <p>
              If the adaption is a translation of one or several existing parts, this can be specified here.
            </p>

            <semantic-table config='{
              "query":"SELECT ?expression ?label ?typeLabel ?language WHERE {
                  ?? ecrm:P165_incorporates ?expression .

                  ?expression ecrm:P2_has_type ?type ;
                    ecrm:P2_has_type sphType:translation ;
                    ecrm:P72_has_language/ecrm:P3_has_note ?language ;
                    efrbroo:R3i_realises ?work .
                  ?part efrbroo:R40i_is_representative_expression_for ?work ;
                    ecrm:P3_has_note ?label .

                  ?type ^skos:member sphType:translationType ;
                    ecrm:P3_has_note ?typeLabel .

                 }",
                "columnConfiguration" : [
                 {
                    "displayName" : "Translated Part",
                    "variableName" : "label"
                 },
                 {
                    "displayName" : "Language",
                    "variableName" : "language"
                 },
                 {
                    "displayName" : "Translation Type",
                    "variableName" : "typeLabel"
                 },
                 {
                   "displayName" : "&nbsp;",
                   "cellTemplate" : "<semantic-link
                     class=\"btn-xs btn-default\"
                     uri=\":addTranslationToAdaption\"
                     urlqueryparam-expressioniri=\"{{expression.value}}\"
                     urlqueryparam-adaptioniri=\"[[this]]\"
                     urlqueryparam-returntab=\"translates\">
                     Edit
                   </semantic-link>
                   <mp-ldp-remove-from-container-action
                     iri=\"{{expression.value}}/container\"
                     container=\"http://www.metaphacts.com/ontologies/platform#formContainer\">

                     <a class=\"btn-default btn-xs\">Delete</a>

                   </mp-ldp-remove-from-container-action>"
                 }
               ],
               "layout":{
                 "options":{
                   "showFilter":false
                 }
               }
             }'>
             </semantic-table>

            <semantic-link
              class="btn btn-md btn-default"
              uri="http://sphaera.mpiwg-berlin.mpg.de/resource/addTranslationToAdaption"
              urlqueryparam-adaptioniri="[[this]]"
              urlqueryparam-returntab="translates"
              [[#if (urlParam "bookiri")]]
                urlqueryparam-bookiri="[[urlParam "bookiri"]]"
              [[/if]]
              [[#if (urlParam "expressioniri")]]
                urlqueryparam-attributeassignmentiri="[[urlParam "expressioniri"]]"
              [[/if]]
              [[#if (urlParam "returniri")]]
                urlqueryparam-returniri="[[urlParam "returniri"]]"
              [[/if]]
              [[#if (urlParam "returntab")]]
                urlqueryparam-returntab="[[urlParam "returntab"]]"
              [[/if]]>
                Add translation
              </semantic-link>

          </bs-tab-pane>
          <bs-tab-pane event-key="meta">
            <h3>Annotations</h3>
            <semantic-table config='{

                "query" : "SELECT ?annotation ?annotation_body WHERE {
                  ?annotation oa:hasTarget ?target ;
                  oa:hasBody/cnt:chars ?annotation_body .
                  BIND(?? as ?target)
                }",
                "columnConfiguration" : [
                  {
                    "displayName" : "Annotation",
                    "variableName" : "annotation_body"
                  },
                  {
                    "displayName" : "&nbsp;",
                    "cellTemplate" : "<semantic-link uri=\"{{annotation.value}}\" class=\"btn-default btn-xs\">Edit</semantic-link>
                      <mp-ldp-remove-from-container-action
                        iri=\"{{annotation.value}}/container\"
                        container=\"http://www.metaphacts.com/ontologies/platform#formContainer\">
                          <a class=\"btn-default btn-xs\">Delete</a>
                      </mp-ldp-remove-from-container-action>"
                  }
                ],
                "layout":{
                  "options":{
                    "showFilter":false
                  }
                }
            }' >
            </semantic-table>
            <semantic-link uri="http://sphaera.mpiwg-berlin.mpg.de/resource/createAnnotation"
              urlqueryparam-resourceiri="[[this]]"
             class="btn btn-default btn-sm"
            >Add Annotation</semantic-link>
          </bs-tab-pane>

          <bs-tab-pane event-key="delete">
            <h3>Delete</h3>
            <p>Use the button below if you like to delete this book from the database</p>

            <semantic-link
                class="btn bn-md btn-danger"
                uri=":deleteResource"
                urlqueryparam-resiri="[[this]]"
                urlqueryparam-back="[[this]]"
                urlqueryparam-backtitle="Parts"
                urlqueryparam-redirect=":listParts"
              >
                Delete Part
              </semantic-link>
          </bs-tab-pane>

          <bs-tab-pane event-key="hidden">
            <div class="disabled hidden-field">
              <h3>Hidden</h3>
              <span class="disabled hidden-field">
                <semantic-form-text-input for="doi"></semantic-form-text-input>
                <semantic-form-text-input for="expression_creation"></semantic-form-text-input>
                <semantic-form-text-input for="expression_record_type"></semantic-form-text-input>
                <semantic-form-text-input for="record_type"></semantic-form-text-input>
                <semantic-form-text-input for="work_record"></semantic-form-text-input>

              </span>
            </div>
          </bs-tab-pane>

          <bs-tab-pane event-key="statements">

            [[> :statements]]
          </bs-tab-pane>

        </bs-tab-content>
      </bs-col>
    </bs-row>
  </bs-tab-container>
  <bs-row>
    <bs-col sm="12" class="text-right form-submit">

            <semantic-query
              query='SELECT ?no_part_assigned WHERE {
                ?? a sphaera:Part_Adaption .
                OPTIONAL {
                  ?? ecrm:P165_incorporates ?part .
                }
                BIND( IF( BOUND(?part), "", "true") as ?no_part_assigned )
              }'
              template='{{#each bindings}}{{#if no_part_assigned.value}}<p>
                Be sure to <em>assign at least one original part</em> under "Annotates" or "Translates"
              </p>{{/if}}{{/each}}'
              >
            </semantic-query>


            [[#if (urlParam "returniri" )]]
              <semantic-link uri="[[urlParam "returniri"]]"
                [[#if (urlParam "returntab" )]]
                  urlqueryparam-tab="[[urlParam "returntab"]]"
                [[/if]]
                [[#if (urlParam "attributeassignmentiri" )]]
                  urlqueryparam-attributeassignmentiri="[[urlParam "attributeassignmentiri"]]"
                [[/if]]
                [[#if (urlParam "bookiri" )]]
                  urlqueryparam-bookiri="[[urlParam "bookiri"]]"
                [[/if]]
                class="btn btn-default btn-md">Cancel</semantic-link>

              [[else]]

                <semantic-link uri=":listParts" class="btn btn-default btn-md">Cancel</semantic-link>

            [[/if]]

            <button name="submit" class="btn btn-primary btn-md">Save</button>      <semantic-form-recover-notification class="alert alert-info"></semantic-form-recover-notification>
    </bs-col>
   </bs-row>
</semantic-form>

[[> :identifier]]

[[> :footer]]
